/**
Config layout nabbed from snesamp
**/


#include "config.h"
#include "../sexyconfig.h"

configWidgets widgets;

inline void updateConfig() {
#define GET_TOGGLE(conf,tog) SEXY_CONFIG.conf = GTK_TOGGLE_BUTTON(widgets.tog)->active
#define GET_SCALE(conf,sca) SEXY_CONFIG.conf = (int)(GTK_SCALE(widgets.sca)->range.adjustment->value)
#define GET_ENTRY(conf,ent,size) strncpy(SEXY_CONFIG.conf,gtk_entry_get_text(GTK_ENTRY(widgets.ent)),size)
#define GET_ENTRY_INT(conf,ent) sscanf(gtk_entry_get_text(GTK_ENTRY(widgets.ent)),"%i",&temp); SEXY_CONFIG.conf = temp
#define GET_COMBO(conf,combo) \
    list = GTK_LIST(GTK_COMBO(widgets.combo)->list); \
    widget = GTK_WIDGET(list->selection->data); \
    SEXY_CONFIG.conf = gtk_list_child_position(list,widget)

  int temp;
  GtkList *list; 
  GtkWidget *widget;

  //DSP
  GET_COMBO(interpolation,interpolationComboBox);
  //GET_COMBO(bits,sampleSizeComboBox);
  GET_COMBO(rate,sampleRateComboBox);
  //GET_COMBO(channels,channelsComboBox);
  GET_SCALE(amplification,amplification);
  GET_SCALE(stereoSeparation,stereoSeparationScale);
  GET_SCALE(echoFeedbackCrosstalk,efcScale);
  temp = 0;
#define OPT(tog,x) if(GTK_TOGGLE_BUTTON(widgets.tog)->active) temp += x
  OPT(hardwareAnomalies,ANOMALIES);
  OPT(oldADPCM,OLD_ADPCM_ROUTINE);
  OPT(surroundSound,SURROUND);
  OPT(reverseStereo,REVERSE_STEREO);
  OPT(disableEcho,NO_ECHO);
  SEXY_CONFIG.dspOptions = temp;

  //Time
  GET_ENTRY_INT(lengthMins,songLenMins);
  GET_ENTRY_INT(lengthSecs,songLenSecs);
  GET_ENTRY_INT(autoEnd,autoEnd);
  GET_ENTRY_INT(loopRepeat,loopRepeat);
  GET_ENTRY_INT(fadeLength,fadeLength);
  GET_ENTRY_INT(trailingSilence,trailingSilence);
  GET_TOGGLE(playIndefinitely,playIndefinitely);
  GET_TOGGLE(overrideSong,overrideSTS);

  //Title
  GET_TOGGLE(titleOverride,overrideGenericTitles);
  GET_ENTRY(titleFormat,titleFormat,32);
}

void applyConfig(GtkWidget *widget, gpointer data) {
  updateConfig();
}

void cancelConfig(GtkWidget *widget) {
  readSexyConfig(); //in case we applied previously
  gtk_widget_destroy(widget);
}

void okConfig(GtkWidget *widget) {
  updateConfig();
  writeSexyConfig();
  gtk_widget_destroy(widget);  
}

GtkWidget *spc_config = NULL;

GtkWidget* create_spc_config (void) {
  GtkWidget *topVBox;
  GtkWidget *notebook;
  GtkWidget *DSPVBox;
  GtkWidget *dspTopTable;
  GtkWidget *interpolationLabel;
  GtkWidget *interpolationComboBox;
  GtkWidget *sampleSizeLabel;
  GtkWidget *sampleSizeComboBox;
  GtkWidget *sampleRateLabel;
  GtkWidget *sampleRateComboBox;
  GtkWidget *channelsLabel;
  GtkWidget *channelsComboBox;
  GtkWidget *dspBottomBox;
  GtkWidget *vbox3;
  GtkWidget *hardwareAnomalies;
  GtkWidget *surroundSound;
  GtkWidget *reverseStereo;
  GtkWidget *oldADPCM;
  GtkWidget *disableEcho;
  GtkWidget *vbox4;
  GtkWidget *vbox26;
  GtkWidget *amplificationLabel;
  GtkWidget *amplification;
  GtkWidget *vbox5;
  GtkWidget *stereoSeparationLabel;
  GtkWidget *stereoSeparationScale;
  GtkWidget *vbox6;
  GtkWidget *efcLabel;
  GtkWidget *efcScale;
  GtkWidget *dspLabel;
  GtkWidget *timeBox;
  GtkWidget *frame2;
  GtkWidget *table2;
  GtkWidget *hbox12;
  GtkWidget *songLenMins;
  GtkWidget *label26;
  GtkWidget *songLenSecs;
  GtkWidget *autoEndLabel;
  GtkWidget *loopRepeatLabel;
  GtkWidget *fadeLengthLabel;
  GtkWidget *songLengthLabel;
  GtkWidget *trailingSilenceLabel;
  GtkWidget *fadeLength;
  GtkWidget *trailingSilence;
  GtkWidget *autoEnd;
  GtkWidget *loopRepeat;
  GtkWidget *playIndefinitely;
  GtkWidget *overrideSTS;
  GtkWidget *timeLabel;
  GtkWidget *vbox24;
  GtkWidget *overrideGenericTitles;
  GtkWidget *hbox16;
  GtkWidget *titleFormatLabel;
  GtkWidget *titleFormat;
  GtkWidget *table5;
  GtkWidget *gameLabel;
  GtkWidget *songLabel;
  GtkWidget *dumperLabel;
  GtkWidget *commentsLabel;
  GtkWidget *emulatorLabel;
  GtkWidget *dateLabel;
  GtkWidget *yearLabel;
  GtkWidget *fileNameLabel;
  GtkWidget *filePathLabel;
  GtkWidget *fileExtensionLabel;
  GtkWidget *trackNumberLabel;
  GtkWidget *titleLabel;
  GtkWidget *buttonRow;
  GtkWidget *filler;
  GtkWidget *ok;
  GtkWidget *cancel;
  GtkWidget *apply;
  GList *glist = NULL;
  char temp[32];

  if (spc_config != NULL) {
    gdk_window_raise(spc_config->window);
    return spc_config;
  }

  spc_config = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_window_set_title (GTK_WINDOW (spc_config), "SNESAmp Configuration");
  gtk_window_set_default_size (GTK_WINDOW (spc_config), 50, 50);
  gtk_window_set_policy(GTK_WINDOW(spc_config),0,0,0);

  topVBox = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (topVBox);
  gtk_container_add (GTK_CONTAINER (spc_config), topVBox);

  notebook = gtk_notebook_new ();
  gtk_widget_show (notebook);
  gtk_box_pack_start (GTK_BOX (topVBox), notebook, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (notebook), 4);

  /**
     DSP Tab
  **/
  DSPVBox = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (DSPVBox);
  gtk_container_add (GTK_CONTAINER (notebook), DSPVBox);

  dspTopTable = gtk_table_new (4, 2, FALSE);
  gtk_widget_show (dspTopTable);
  gtk_box_pack_start (GTK_BOX (DSPVBox), dspTopTable, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (dspTopTable), 4);
  gtk_table_set_row_spacings (GTK_TABLE (dspTopTable), 4);
  gtk_table_set_col_spacings (GTK_TABLE (dspTopTable), 4);

#define TABLE(a,b,c,d,e) gtk_table_attach(GTK_TABLE(dspTopTable), a, b, c, d, e, 0, 0, 0, 0)
#define COMBOA(a) a = gtk_combo_new(); gtk_widget_show(a); gtk_widget_set_usize(a, 90, -1)
#define COMBOB(a,b) \
        gtk_combo_set_popdown_strings(GTK_COMBO(a),glist); \
        gtk_entry_set_text (GTK_ENTRY(GTK_COMBO(a)->entry), (char*)g_list_nth_data(glist,SEXY_CONFIG.b)); \
        gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(a)->entry),0); \
        g_list_free(glist); \
        glist = NULL

  sampleRateLabel = gtk_label_new ("Sample Rate");
  gtk_widget_show (sampleRateLabel);
  TABLE(sampleRateLabel,0,1,0,1);

  COMBOA(sampleRateComboBox);  
  glist = g_list_append(glist, "8000"); 
  glist = g_list_append(glist, "11025");
  glist = g_list_append(glist, "16000");
  glist = g_list_append(glist, "22050");
  glist = g_list_append(glist, "32000");
  glist = g_list_append(glist, "44100");
  glist = g_list_append(glist, "48000");
  glist = g_list_append(glist, "88200");
  glist = g_list_append(glist, "96000");
  glist = g_list_append(glist, "176400");
  glist = g_list_append(glist, "192000");
  COMBOB(sampleRateComboBox,rate);
  TABLE(sampleRateComboBox,1,2,0,1);


  channelsLabel = gtk_label_new ("Channels");
  gtk_widget_show (channelsLabel);
  TABLE(channelsLabel,2,3,0,1);

  COMBOA(channelsComboBox);
  glist = g_list_append(glist, "Monaural");
  glist = g_list_append(glist, "Stereo");
  COMBOB(channelsComboBox,channels);
  TABLE(channelsComboBox,3,4,0,1);


  sampleSizeLabel = gtk_label_new ("Sample Size");
  gtk_widget_show (sampleSizeLabel);
  TABLE(sampleSizeLabel,0,1,1,2);

  COMBOA(sampleSizeComboBox);
  glist = g_list_append(glist, "8-bit");
  glist = g_list_append(glist, "16-bit");
  glist = g_list_append(glist, "24-bit"); 
  glist = g_list_append(glist, "32-bit");
  COMBOB(sampleSizeComboBox,bits);
  TABLE(sampleSizeComboBox,1,2,1,2);


  interpolationLabel = gtk_label_new ("Interpolation");
  gtk_widget_show (interpolationLabel);
  TABLE(interpolationLabel,2,3,1,2);

  COMBOA(interpolationComboBox);
  glist = g_list_append(glist, "None");
  glist = g_list_append(glist, "Linear");
  glist = g_list_append(glist, "Cubic"); 
  glist = g_list_append(glist, "Gaussian");
  COMBOB(interpolationComboBox,interpolation);
  TABLE(interpolationComboBox,3,4,1,2);


  dspBottomBox = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (dspBottomBox);
  gtk_box_pack_start (GTK_BOX (DSPVBox), dspBottomBox, FALSE, TRUE, 0);

  vbox3 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox3);
  gtk_box_pack_start (GTK_BOX (dspBottomBox), vbox3, FALSE, TRUE, 0);

#define OPTION(a,b,c) \
    a = gtk_check_button_new_with_label(b); \
    gtk_widget_show(a); \
    gtk_toggle_button_set_active(&(GTK_CHECK_BUTTON(a)->toggle_button),SEXY_CONFIG.dspOptions&c); \
    gtk_box_pack_start(GTK_BOX(vbox3), a, FALSE, FALSE, 0)

  OPTION(hardwareAnomalies,"Simulate Analog Anomalies",ANOMALIES);
  OPTION(surroundSound,"\"Surround\" Sound",SURROUND);
  OPTION(reverseStereo,"Reverse Stereo",REVERSE_STEREO);
  OPTION(oldADPCM,"Use old ADPCM",OLD_ADPCM_ROUTINE);
  OPTION(disableEcho,"Disable Echo",NO_ECHO);

  vbox4 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox4);
  gtk_box_pack_start (GTK_BOX (dspBottomBox), vbox4, TRUE, TRUE, 0);

#define SCALE(a,b,c,d,e,f,g) \
      a = gtk_vbox_new(FALSE, 0); \
      gtk_widget_show(a); \
      gtk_box_pack_start(GTK_BOX(vbox4), a, TRUE, TRUE, 0); \
      b = gtk_label_new(c); \
      gtk_widget_show(b); \
      gtk_box_pack_start (GTK_BOX(a), b, FALSE, FALSE, 0); \
      d = gtk_hscale_new(GTK_ADJUSTMENT(gtk_adjustment_new(SEXY_CONFIG.e, f, g, 0, 0, 0))); \
      gtk_scale_set_digits(GTK_SCALE(d),0); \
      gtk_widget_show (d); \
      gtk_widget_set_usize (d, 150, -1); \
      gtk_box_pack_start (GTK_BOX (a), d, TRUE, TRUE, 0); \
      gtk_scale_set_value_pos (GTK_SCALE (d), GTK_POS_RIGHT)

  SCALE(vbox26,amplificationLabel,"Amplification",amplification,amplification,0,10);
  SCALE(vbox5,stereoSeparationLabel,"Stereo Separation",stereoSeparationScale,stereoSeparation,0,100);
  SCALE(vbox6,efcLabel,"Echo Feedback Crosstalk",efcScale,echoFeedbackCrosstalk,-100,100);

  dspLabel = gtk_label_new ("DSP");
  gtk_widget_show (dspLabel);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook), 0), dspLabel);

  /**
     Time Tab
  **/
  timeBox = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (timeBox);
  gtk_container_add (GTK_CONTAINER (notebook), timeBox);

  frame2 = gtk_frame_new (NULL);
  gtk_widget_show (frame2);
  gtk_box_pack_start (GTK_BOX (timeBox), frame2, FALSE, TRUE, 5);
  gtk_container_set_border_width (GTK_CONTAINER (frame2), 2);
  gtk_frame_set_shadow_type (GTK_FRAME (frame2), GTK_SHADOW_ETCHED_IN);

  gtk_frame_set_label(GTK_FRAME (frame2), "Default Time Settings");

  table2 = gtk_table_new (3, 4, FALSE);
  gtk_widget_show (table2);
  gtk_container_add (GTK_CONTAINER (frame2), table2);
  gtk_table_set_row_spacings (GTK_TABLE (table2), 2);
  gtk_table_set_col_spacings (GTK_TABLE (table2), 6);

  hbox12 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox12);
  gtk_table_attach (GTK_TABLE (table2), hbox12, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),                    
                    (GtkAttachOptions) (0), 0, 0);

  songLenMins = gtk_entry_new ();
  gtk_widget_show (songLenMins);
  gtk_widget_set_usize(songLenMins, 35, -1);
  gtk_box_pack_start (GTK_BOX (hbox12), songLenMins, TRUE, TRUE, 0);
  gtk_entry_set_max_length (GTK_ENTRY (songLenMins), 2);
  snprintf(temp,32,"%i",SEXY_CONFIG.lengthMins);
  gtk_entry_set_text(GTK_ENTRY(songLenMins),temp);

  label26 = gtk_label_new (":");
  gtk_widget_show (label26);
  gtk_widget_set_usize(label26, 5, -1);
  gtk_box_pack_start (GTK_BOX (hbox12), label26, FALSE, FALSE, 0);

  songLenSecs = gtk_entry_new ();
  gtk_widget_show (songLenSecs);
  gtk_widget_set_usize(songLenSecs, 35, -1);
  gtk_box_pack_start (GTK_BOX (hbox12), songLenSecs, TRUE, TRUE, 0);
  gtk_entry_set_max_length (GTK_ENTRY (songLenSecs), 2);
  snprintf(temp,32,"%.2d",SEXY_CONFIG.lengthSecs);
  gtk_entry_set_text(GTK_ENTRY(songLenSecs),temp);

  songLengthLabel = gtk_label_new ("Song Length");
  gtk_widget_show (songLengthLabel);
  gtk_table_attach (GTK_TABLE (table2), songLengthLabel, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (songLengthLabel), GTK_JUSTIFY_RIGHT);
  gtk_misc_set_alignment (GTK_MISC (songLengthLabel), 0.9, 0.5);

#define TIME_ENTRY(label,text,entry,a,b,c,d,conf) \
  label = gtk_label_new(text); \
  gtk_widget_show(label); \
  gtk_table_attach (GTK_TABLE (table2), label, a, b, c, d, \
                    (GtkAttachOptions) (GTK_FILL), \
                    (GtkAttachOptions) (0), 0, 0); \
  entry = gtk_entry_new(); \
  gtk_widget_show(entry); \
  gtk_table_attach (GTK_TABLE (table2), entry, a+1, b+1, c, d, \
                    (GtkAttachOptions) (GTK_FILL), \
                    (GtkAttachOptions) (0), 0, 0); \
  gtk_widget_set_usize (entry, 80, -1); \
  gtk_entry_set_max_length(GTK_ENTRY(entry), 4); \
  snprintf(temp,32,"%i",SEXY_CONFIG.conf); \
  gtk_entry_set_text(GTK_ENTRY(entry),temp)

  TIME_ENTRY(autoEndLabel,"Auto End",autoEnd,2,3,0,1,autoEnd);
  TIME_ENTRY(loopRepeatLabel,"Loop Repeat",loopRepeat,2,3,1,2,loopRepeat);
  TIME_ENTRY(fadeLengthLabel,"Fade Length",fadeLength,0,1,1,2,fadeLength);
  TIME_ENTRY(trailingSilenceLabel,"Trailing Silence",trailingSilence,0,1,2,3,trailingSilence);

#define TIME_OPT(toggle,label,conf) \
  toggle = gtk_check_button_new_with_label (label); \
  gtk_widget_show(toggle); \
  gtk_toggle_button_set_active(&(GTK_CHECK_BUTTON(toggle)->toggle_button),SEXY_CONFIG.conf); \
  gtk_box_pack_start (GTK_BOX (timeBox), toggle, FALSE, FALSE, 0)

  TIME_OPT(playIndefinitely,"Play Songs Indefinitely",playIndefinitely);
  TIME_OPT(overrideSTS,"Override Song Time Settings",overrideSong);

  timeLabel = gtk_label_new ("Time");
  gtk_widget_show (timeLabel);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook), 1), timeLabel);

  /**
     Title Tab
  **/
  vbox24 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox24);
  gtk_container_add (GTK_CONTAINER (notebook), vbox24);

  overrideGenericTitles = gtk_check_button_new_with_label ("Override generic titles");
  gtk_toggle_button_set_active(&GTK_CHECK_BUTTON(overrideGenericTitles)->toggle_button,SEXY_CONFIG.titleOverride);
  gtk_widget_show (overrideGenericTitles);
  gtk_box_pack_start (GTK_BOX (vbox24), overrideGenericTitles, FALSE, FALSE, 0);

  hbox16 = gtk_hbox_new (FALSE, 2);
  gtk_widget_show (hbox16);
  gtk_box_pack_start (GTK_BOX (vbox24), hbox16, TRUE, TRUE, 0);

  titleFormatLabel = gtk_label_new ("Title format: ");
  gtk_widget_show (titleFormatLabel);
  gtk_box_pack_start (GTK_BOX (hbox16), titleFormatLabel, FALSE, FALSE, 0);

  titleFormat = gtk_entry_new();
  gtk_widget_show (titleFormat);
  gtk_entry_set_text(GTK_ENTRY(titleFormat),SEXY_CONFIG.titleFormat);
  gtk_box_pack_start (GTK_BOX (hbox16), titleFormat, TRUE, TRUE, 0);

  table5 = gtk_table_new (6, 2, FALSE);
  gtk_widget_show (table5);
  gtk_box_pack_start (GTK_BOX (vbox24), table5, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (table5), 5);
  gtk_table_set_row_spacings (GTK_TABLE (table5), 2);
  gtk_table_set_col_spacings (GTK_TABLE (table5), 5);

  gameLabel = gtk_label_new ("%a - Game");
  gtk_widget_show (gameLabel);
  gtk_table_attach (GTK_TABLE (table5), gameLabel, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  GTK_WIDGET_SET_FLAGS (gameLabel, GTK_CAN_FOCUS);
  gtk_misc_set_alignment (GTK_MISC (gameLabel), 0, 0.5);

  songLabel = gtk_label_new ("%t - Song");
  gtk_widget_show (songLabel);
  gtk_table_attach (GTK_TABLE (table5), songLabel, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  GTK_WIDGET_SET_FLAGS (songLabel, GTK_CAN_FOCUS);
  gtk_misc_set_alignment (GTK_MISC (songLabel), 0, 0.5);

  dumperLabel = gtk_label_new ("%p - Dumper");
  gtk_widget_show (dumperLabel);
  gtk_table_attach (GTK_TABLE (table5), dumperLabel, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  GTK_WIDGET_SET_FLAGS (dumperLabel, GTK_CAN_FOCUS);
  gtk_misc_set_alignment (GTK_MISC (dumperLabel), 0, 0.5);

  commentsLabel = gtk_label_new ("%c - Comments");
  gtk_widget_show (commentsLabel);
  gtk_table_attach (GTK_TABLE (table5), commentsLabel, 0, 1, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  GTK_WIDGET_SET_FLAGS (commentsLabel, GTK_CAN_FOCUS);
  gtk_misc_set_alignment (GTK_MISC (commentsLabel), 0, 0.5);

  emulatorLabel = gtk_label_new ("%g - Emulator");
  gtk_widget_show (emulatorLabel);
  gtk_table_attach (GTK_TABLE (table5), emulatorLabel, 0, 1, 4, 5,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  GTK_WIDGET_SET_FLAGS (emulatorLabel, GTK_CAN_FOCUS);
  gtk_misc_set_alignment (GTK_MISC (emulatorLabel), 0, 0.5);

  dateLabel = gtk_label_new ("%d - Date");
  gtk_widget_show (dateLabel);
  gtk_table_attach (GTK_TABLE (table5), dateLabel, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  GTK_WIDGET_SET_FLAGS (dateLabel, GTK_CAN_FOCUS);
  gtk_misc_set_alignment (GTK_MISC (dateLabel), 0, 0.5);

  yearLabel = gtk_label_new ("%y - Year");
  gtk_widget_show (yearLabel);
  gtk_table_attach (GTK_TABLE (table5), yearLabel, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  GTK_WIDGET_SET_FLAGS (yearLabel, GTK_CAN_FOCUS);
  gtk_misc_set_alignment (GTK_MISC (yearLabel), 0, 0.5);

  fileNameLabel = gtk_label_new ("%f - File Name");
  gtk_widget_show (fileNameLabel);
  gtk_table_attach (GTK_TABLE (table5), fileNameLabel, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  GTK_WIDGET_SET_FLAGS (fileNameLabel, GTK_CAN_FOCUS);
  gtk_misc_set_alignment (GTK_MISC (fileNameLabel), 0, 0.5);

  filePathLabel = gtk_label_new ("%F - File Path");
  gtk_widget_show (filePathLabel);
  gtk_table_attach (GTK_TABLE (table5), filePathLabel, 1, 2, 3, 4,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  GTK_WIDGET_SET_FLAGS (filePathLabel, GTK_CAN_FOCUS);
  gtk_misc_set_alignment (GTK_MISC (filePathLabel), 0, 0.5);

  fileExtensionLabel = gtk_label_new ("%e - File Extention");
  gtk_widget_show (fileExtensionLabel);
  gtk_table_attach (GTK_TABLE (table5), fileExtensionLabel, 1, 2, 4, 5,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  GTK_WIDGET_SET_FLAGS (fileExtensionLabel, GTK_CAN_FOCUS);
  gtk_misc_set_alignment (GTK_MISC (fileExtensionLabel), 0, 0.5);

  trackNumberLabel = gtk_label_new ("%n - Track Number");
  gtk_widget_show (trackNumberLabel);
  gtk_table_attach (GTK_TABLE (table5), trackNumberLabel, 0, 1, 5, 6,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  GTK_WIDGET_SET_FLAGS (trackNumberLabel, GTK_CAN_FOCUS);

  titleLabel = gtk_label_new ("Title");
  gtk_widget_show (titleLabel);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook), 2), titleLabel);

  /**
     Button Row
  **/
  buttonRow = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (buttonRow);
  gtk_box_pack_start (GTK_BOX (topVBox), buttonRow, FALSE, TRUE, 0);

  filler = gtk_label_new ("");
  gtk_widget_show (filler);
  gtk_box_pack_start (GTK_BOX (buttonRow), filler, TRUE, TRUE, 0);

  ok = gtk_button_new_with_label ("OK");
  gtk_widget_show (ok);
  gtk_widget_set_usize (ok, 80, -1);
  gtk_box_pack_start (GTK_BOX (buttonRow), ok, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (ok), 5);

  cancel = gtk_button_new_with_label ("Cancel");
  gtk_widget_show (cancel);
  gtk_widget_set_usize (cancel, 80, -1);
  gtk_box_pack_start (GTK_BOX (buttonRow), cancel, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (cancel), 5);

  apply = gtk_button_new_with_label ("Apply");
  gtk_widget_show (apply);
  gtk_widget_set_usize (apply, 80, -1);
  gtk_box_pack_start (GTK_BOX (buttonRow), apply, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (apply), 5);

#define APPLE(a) widgets.a = a;
  APPLE(interpolationComboBox);
  APPLE(sampleSizeComboBox);
  APPLE(sampleRateComboBox);
  APPLE(channelsComboBox);
  APPLE(hardwareAnomalies);
  APPLE(surroundSound);
  APPLE(reverseStereo);
  APPLE(oldADPCM);
  APPLE(disableEcho);
  APPLE(amplification);
  APPLE(stereoSeparationScale);
  APPLE(efcScale);
  APPLE(songLenMins);
  APPLE(songLenSecs);
  APPLE(fadeLength);
  APPLE(trailingSilence);
  APPLE(autoEnd);
  APPLE(loopRepeat);
  APPLE(playIndefinitely);
  APPLE(overrideSTS);
  APPLE(overrideGenericTitles);
  APPLE(titleFormat);
  APPLE(ok);
  APPLE(cancel);
  APPLE(apply);

  gtk_signal_connect_object ((gpointer)cancel, "clicked",
                            GTK_SIGNAL_FUNC(cancelConfig),
                            GTK_OBJECT(spc_config));

  gtk_signal_connect_object ((gpointer)ok, "clicked",
                            GTK_SIGNAL_FUNC(okConfig),
                            GTK_OBJECT(spc_config));

  gtk_signal_connect (GTK_OBJECT(apply), "clicked", GTK_SIGNAL_FUNC(applyConfig), NULL);

  gtk_signal_connect(GTK_OBJECT(spc_config), "destroy", 
		     GTK_SIGNAL_FUNC(gtk_widget_destroyed), 
		     &spc_config);

  return spc_config;
}
