#include "Types.h"
#include "sexyconfig.h"
#include <xmms/configfile.h>
#include "SNESAPU/DSP.h"

SexyConfig SEXY_CONFIG = {STEREO,SAMPLE_16_BIT,RATE32000,INTERPOLATION_GAUSSIAN,0,0,"",3,0,3,0,0,0,0,0,0,0,0}; //default values

//reading something that doesn't exist doesn't change the value that is being written to
void readSexyConfig() {
  ConfigFile *conf = xmms_cfg_open_default_file();
#define READINT(var) xmms_cfg_read_int(conf,"sexyspc",#var,&SEXY_CONFIG.var)
#define READSTR(var) char *tmp; xmms_cfg_read_string(conf,"sexyspc",#var,&tmp); strncpy(SEXY_CONFIG.var,tmp,32)
  //READINT(channels);
  //READINT(bits);
  READINT(rate);
  READINT(interpolation);
  READINT(dspOptions);
  READINT(titleOverride);
  READSTR(titleFormat);
  READINT(lengthMins);
  READINT(lengthSecs);
  READINT(amplification);
  READINT(stereoSeparation);
  READINT(echoFeedbackCrosstalk);
  READINT(autoEnd);
  READINT(loopRepeat);
  READINT(fadeLength);
  READINT(trailingSilence);
  READINT(playIndefinitely);
  READINT(overrideSong);
}

void writeSexyConfig() {
  ConfigFile *conf = xmms_cfg_open_default_file();
#define WRITEINT(var) xmms_cfg_write_int(conf,"sexyspc",#var,SEXY_CONFIG.var);
#define WRITESTR(var) xmms_cfg_write_string(conf,"sexyspc",#var,SEXY_CONFIG.var);
  //WRITEINT(channels);
  //WRITEINT(bits);
  WRITEINT(rate);
  WRITEINT(interpolation);
  WRITEINT(dspOptions);
  WRITEINT(titleOverride);
  WRITESTR(titleFormat);
  WRITEINT(lengthMins);
  WRITEINT(lengthSecs);
  WRITEINT(amplification);
  WRITEINT(stereoSeparation);
  WRITEINT(echoFeedbackCrosstalk);
  WRITEINT(autoEnd);
  WRITEINT(loopRepeat);
  WRITEINT(fadeLength);
  WRITEINT(trailingSilence);
  WRITEINT(playIndefinitely);
  WRITEINT(overrideSong);
  xmms_cfg_write_default_file(conf);
}

int channels(SexyConfig *config) {
  return config->channels+1;
}

int bits(SexyConfig *config) {
  switch(config->bits) {
#define SAMPLE(x) case SAMPLE_##x##_BIT: return x
    SAMPLE(8);
    SAMPLE(16);
    SAMPLE(24);
    SAMPLE(32);
  }
  return 8;
}

int rate(SexyConfig *config) {
  switch(config->rate) {
#define RATE(x) case RATE##x: return x
    RATE(8000);
    RATE(11025);
    RATE(16000);
    RATE(22050);
    RATE(32000);
    RATE(44100);
    RATE(48000);
    RATE(88200);
    RATE(96000);
    RATE(176400);
    RATE(192000);
  }
  return 8000;
}

int interpolation(SexyConfig *config) {
  return config->interpolation; //same value as in DSP.h
}

int dspOptions(SexyConfig *config) {
  return config->dspOptions; //stored the same way as DSP.h
}
