#define RATE8000 0
#define RATE11025 1
#define RATE16000 2
#define RATE22050 3
#define RATE32000 4
#define RATE44100 5
#define RATE48000 6
#define RATE88200 7
#define RATE96000 8
#define RATE176400 9
#define RATE192000 10

#define MONAURAL 0
#define STEREO 1

#define SAMPLE_8_BIT 0
#define SAMPLE_16_BIT 1
#define SAMPLE_24_BIT 2
#define SAMPLE_32_BIT 3

#define INTERPOLATION_NONE 0
#define INTERPOLATION_LINEAR 1
#define INTEROPLATION_CUBIC 2
#define INTERPOLATION_GAUSSIAN 3

#define	ANOMALIES 0x01
#define	OLD_ADPCM_ROUTINE 0x02
#define	SURROUND 0x04
#define	REVERSE_STEREO 0x08
#define	NO_ECHO 0x10

typedef struct {
  int channels;
  int bits;
  int rate;
  int interpolation;
  int dspOptions;
  unsigned char titleOverride;
  char titleFormat[32];
  int lengthMins;
  int lengthSecs;
  int amplification;
  int stereoSeparation;
  int echoFeedbackCrosstalk;
  int autoEnd;
  int loopRepeat;
  int fadeLength;
  int trailingSilence;
  unsigned char playIndefinitely;
  unsigned char overrideSong;
} SexyConfig;

void readSexyConfig();
void writeSexyConfig();

int channels(SexyConfig *config);
int bits(SexyConfig *config);
int rate(SexyConfig *config);
int interpolation(SexyConfig *config);
int dspOptions(SexyConfig *config);

extern SexyConfig SEXY_CONFIG;
