typedef struct {
  unsigned char pc[2];
  unsigned char a;
  unsigned char x;
  unsigned char y;
  unsigned char psw;
  unsigned char sp;
} SPCRegisters;

typedef struct {
  char fTag[33];
  char tTerm[3];
  char ver;
  SPCRegisters reg;
  unsigned short __r1;
} SPCHeader;

typedef struct {
  unsigned char	APURAM[65536];
  unsigned char	dsp[128];
  unsigned char	unused[64];
  unsigned char	extraRAM[64];
} SPCData;

typedef struct {
  unsigned char isBinary;
  char song[32];
  char game[32];
  char dumper[16];
  char comments[32];
  int day,month,year;
  unsigned long length;
  unsigned long fade;
  char artist[32];
  unsigned char muted;
  unsigned char emulator;
} ID666;

typedef struct {
  char song[256];
  char game[256];
  char artist[256];
  char dumper[256];
  int day,month,year;
  unsigned char emulator;
  char comments[256];
  char OSTTitle[256];
  unsigned short OSTDisc;
  char OSTTrackChar;  
  unsigned short OSTTrack;
  char publisher[256];
  unsigned short copyrightYear;
  unsigned long intro;
  unsigned long loop;
  signed long end;
  unsigned long fade;
  unsigned char muted;
  unsigned short loopTimes;
  unsigned long amplification;
} ID666ext;

typedef struct {
  ID666 id666;
  SPCHeader header;
  SPCData data;
  unsigned char dsp[128];
  unsigned char extraRAM[64];
  unsigned char hasID666ext;
  ID666ext id666ext;
  unsigned long totallength;
  char filename[256];
} SPCInfo;

#define NUM_EMULATORS 7
extern const char emulators[7][12];

int LoadSPC(char *fn, SPCInfo *info, void *pAPURAM);
void SetSPC(SPCInfo *info, void *pAPURAM);
void KillSPC(SPCInfo *info);
const char* getEmulator(int emu);
int WriteID666(char *fn, ID666 *id666);
